%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Metzen et al. Neural correlations enable invariant coding and perception
% of natural stimuli
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tuning curve midbrain neurons chirps
% code to analyze neuronal data of midbrain TS
% 1st update Feb 2016 removed PEAK RESPONSE ALIGNMENT for all measures

clear
% run through all groups
grps=1:1:32;

%% single unit responses
for beige=1:length(grps)
    gr=grps(beige);
    location=['C:\Users\mmetzen\Desktop\eLife_resub_files\data_afferents\recombined\gr' num2str(gr) '\'];
    cd([location])
    FileList=dir('*.mat');
    n=size(FileList,1);
    
    for rot=1:n
        load(FileList(rot,1).name);
        psth_R(:,rot)=psth_corr;
        RRbeattemp(:,rot)=mean(psth_corr(1:(length(psth_corr)*0.5)-500));
        psth_FiRa(:,rot)=psth_FR;
        FRbeattemp(:,rot)=mean(psth_FR(1:(length(psth_FR)*0.5)-500));
        signal(:,rot)=signal_newnew;
    end
    RRbeat(:,beige)=RRbeattemp;
    FRbeat(:,beige)=FRbeattemp;
    
    %% sim measure data
    beat=4;
    timewindow=0.03; % in sec
    
    for gelb=1:size(signal,2)
        temp(:,gelb)=decimate(signal(1:end-1,gelb),10);
    end
    [peaks,loc,wdt]=findpeaks(signal(:,1),[1:1:length(signal(:,1))],'Annotate','extents','WidthReference','halfheight','MinPeakHeight',0.8);
    wind=round((loc(end)-loc(end-1))*beat*timewindow)/10;
    
    for gelb=1:8
        scmt(:,gelb)=temp(round(length(temp)*0.5):round(length(temp)*0.5)+wind,gelb);
        ttemp=psth_FiRa(round(length(psth_FiRa)*0.5):round(length(psth_FiRa)*0.5)+wind,gelb);
        tttemp=psth_R(round(length(psth_R)*0.5):round(length(psth_R)*0.5)+wind,gelb);
        frm(:,gelb)=ttemp;
        corm(:,gelb)=tttemp;
        frm_norm(:,gelb)=ttemp./max((ttemp));
        corm_norm(:,gelb)=tttemp./max((tttemp));
    end
    
    %----- UPDATE FEB 2016------
    % for population response
    frmpop{beige}=frm;
    cormpop{beige}=corm;
    %---------------------------
    
    %%
    clear newfrm newcorm newstim
    newstim=scmt;
    newfrm=frm;
    newcorm=corm;
    % tuning response single units and correlations
    tchirpPSTHs=(0:1/4000:0.03);
    for I=1:8
        ind=(find(tchirpPSTHs>=(0.015-0.0075) & tchirpPSTHs<=(0.015+0.0075))); % 0.0075
        ind2=(find(tchirpPSTHs>=(0.015-0.01) & tchirpPSTHs<=(0.015+0.01))); % 0.0075
        if mean(FRbeat(:,beige))==0
            nenner=0.001;
        else
            nenner=mean(FRbeat(:,beige));
        end
        if mean(RRbeat(:,beige))==0
            nennerR=0.001;
        else
            nennerR=mean(RRbeat(:,beige));
        end
        valFRtemp(I)=mean(newfrm(ind,I))/nenner;
        valRtemp(I)=mean(newcorm(ind2,I))/nennerR;
    end
    valFR(beige,:)=(valFRtemp);
    valRR(beige,:)=(valRtemp);
    
    %% ALL chirps
    takeon=[4 5 6 7];
    takeoff=[1 2 3 8];
    takeall=[];
    newfrm(takeall,:)=[];
    newcorm(takeall,:)=[];
    newstim(takeall,:)=[];
    
    num_stim=size(newstim,2);
    pairs=nchoosek(1:1:num_stim,2);
    
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_SC(I)]=simmeas(newstim(:,take(1)),newstim(:,take(2)));
        [~,sim_RR_al(I)]=simmeas(newcorm(:,take(1)),newcorm(:,take(2)));
        [~,sim_FR_al(I)]=simmeas(newfrm(:,take(1)),newfrm(:,take(2)));
    end
    
    sim_SC22=sim_SC;
    ind22=find(isnan(sim_FR_al));
    sim_FR_al(ind22)=[];
    sim_SC22(ind22)=[];
    ratio=(sim_FR_al./sim_SC22);
    ratio(ratio>1)=1;
    FI_al(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    sim_SC33=sim_SC;
    ind33=find(isnan(sim_RR_al));
    sim_RR_al(ind33)=[];
    sim_SC33(ind33)=[];
    ratio=(sim_RR_al./sim_SC33);
    ratio(ratio>1)=1;
    FI_R_al(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    simiFR{beige}.sim=sim_FR_al;
    simiSC{beige}.sim=sim_SC;
    simiRR{beige}.sim=sim_RR_al;
    
    %% minus chirps
    takeon=[4 5 6 7];
    takeoff=[1 2 3 8];
    takeall=[];
    newfrm=frm;
    newcorm=corm;
    newfrm(takeon,:)=[];
    newcorm(takeon,:)=[];
    newstim(takeon,:)=[];
    
    num_stim=size(newstim,2);
    pairs=nchoosek(1:1:num_stim,2);
    
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_SC(I)]=simmeas(newstim(:,take(1)),newstim(:,take(2)));
        [~,sim_RR_al(I)]=simmeas(newcorm(:,take(1)),newcorm(:,take(2)));
        [~,sim_FR_al(I)]=simmeas(newfrm(:,take(1)),newfrm(:,take(2)));
    end
    
    sim_SC22=sim_SC;
    ind22=find(isnan(sim_FR_al));
    sim_FR_al(ind22)=[];
    sim_SC22(ind22)=[];
    ratio=(sim_FR_al./sim_SC22);
    ratio(ratio>1)=1;
    FI_off(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    sim_SC33=sim_SC;
    ind33=find(isnan(sim_RR_al));
    sim_RR_al(ind33)=[];
    sim_SC33(ind33)=[];
    ratio=(sim_RR_al./sim_SC33);
    ratio(ratio>1)=1;
    FI_R_off(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    %% plus chirps
    takeon=[4 5 6 7];
    takeoff=[1 2 3 8];
    takeall=[];
    newfrm=frm;
    newcorm=corm;
    newfrm(takeoff,:)=[];
    newcorm(takeoff,:)=[];
    newstim(takeoff,:)=[];
    
    num_stim=size(newstim,2);
    pairs=nchoosek(1:1:num_stim,2);
    
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_SC(I)]=simmeas(newstim(:,take(1)),newstim(:,take(2)));
        [~,sim_RR_al(I)]=simmeas(newcorm(:,take(1)),newcorm(:,take(2)));
        [~,sim_FR_al(I)]=simmeas(newfrm(:,take(1)),newfrm(:,take(2)));
    end
    
    sim_SC22=sim_SC;
    ind22=find(isnan(sim_FR_al));
    sim_FR_al(ind22)=[];
    sim_SC22(ind22)=[];
    ratio=(sim_FR_al./sim_SC22);
    ratio(ratio>1)=1;
    FI_on(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    sim_SC33=sim_SC;
    ind33=find(isnan(sim_RR_al));
    sim_RR_al(ind33)=[];
    sim_SC33(ind33)=[];
    ratio=(sim_RR_al./sim_SC33);
    ratio(ratio>1)=1;
    FI_R_on(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    %% inter chirp (plus vs minus)
    %--update Feb 2016-----
    takeon=[4 5 6 7];
    takeoff=[1 2 3 8];
    takeall=[];
    newfrm=frm;
    newcorm=corm;
    newfrm(takeall,:)=[];
    newcorm(takeall,:)=[];
    newstim(takeall,:)=[];
    pairs=combvec(takeon,takeoff)';
    
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_SC(I)]=simmeas(newstim(:,take(1)),newstim(:,take(2)));
        [~,sim_RR_int(I)]=simmeas(newcorm(:,take(1)),newcorm(:,take(2)));
        [~,sim_FR_int(I)]=simmeas(newfrm(:,take(1)),newfrm(:,take(2)));
    end
    
    sim_SC44=sim_SC;
    ind44=find(isnan(sim_FR_al));
    sim_FR_al(ind44)=[];
    sim_SC44(ind44)=[];
    ratio=(sim_FR_al./sim_SC44);
    ratio(ratio>1)=1;
    FI_int(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    
    sim_SC44=sim_SC;
    ind44=find(isnan(sim_RR_int));
    sim_RR_int(ind44)=[];
    sim_SC44(ind44)=[];
    ratio=(sim_RR_al./sim_SC44);
    ratio(ratio>1)=1;
    FI_R_int(beige)=1-((sum(ratio))/(length(ratio)));
    clear ratio
    %------------------
    display('DONE')
end
%--update Feb 2016-----
% population FI
for GER=1:8
    for CAN=1:size(cormpop,2)
        tempFR(:,CAN)=frmpop{1, CAN}(:,GER);
        tempR(:,CAN)=cormpop{1, CAN}(:,GER);
    end
    FRpop(:,GER)=mean(tempFR,2);
    RRpop(:,GER)=mean(tempR,2);
    clear tempFR tempR
end
num_stim=size(newstim,2);
pairs=nchoosek(1:1:num_stim,2);
for I=1:size(pairs,1)
    take=pairs(I,:);
    [~,sim_SC(I)]=simmeas(newstim(:,take(1)),newstim(:,take(2)));
    [~,sim_RR_pop(I)]=simmeas(RRpop(:,take(1)),RRpop(:,take(2)));
    [~,sim_FR_pop(I)]=simmeas(FRpop(:,take(1)),FRpop(:,take(2)));
end

sim_SC111=sim_SC;
ind111=find(isnan(sim_FR_pop));
sim_FR_pop(ind111)=[];
sim_SC111(ind111)=[];
ratio=(sim_FR_pop./sim_SC111);
ratio(ratio>1)=1;
FI_FR_pop=1-((sum(ratio))/(length(ratio)))
clear ratio

sim_SC112=sim_SC;
ind112=find(isnan(sim_RR_pop));
sim_RR_pop(ind112)=[];
sim_SC112(ind112)=[];
ratio=(sim_RR_pop./sim_SC112);
ratio(ratio>1)=1;
FI_RR_pop=1-((sum(ratio))/(length(ratio)))
clear ratio
%%
figure; % scatter plot sim stim vs sim resp for each neuron
for MG=1:size(simiSC,2)
    hold on;plot(simiSC{1,MG}.sim,simiFR{1,MG}.sim,'.','markersize',10)
end
xlim([0.1 1.25]);ylim([0.1 1.25])
hold on;refline(1,0)
title('single cells');xlabel('Distance Stimulus');ylabel('Distance Response');logx;logy

figure; % scatter plot sim stim vs sim resp for each pair (correlation)
for MG=1:size(simiSC,2)
    hold on;plot(simiSC{1,MG}.sim,simiRR{1,MG}.sim,'.','markersize',10)
end
xlim([0.1 1.25]);ylim([0.1 1.25])
hold on;refline(1,0)
title('correlation');xlabel('Distance Stimulus');ylabel('Distance Response');logx;logy

meanvali=[mean(FI_al) mean([FI_on FI_off]) mean(FI_int) mean(FI_R_al) mean([FI_R_off FI_R_off]) mean(FI_R_int)];
SEvali=[std(FI_al)/sqrt(length(FI_al)) std([FI_on FI_off])/sqrt(length([FI_on FI_off])) std(FI_int)/sqrt(length(FI_int)) std(FI_R_al)/sqrt(length(FI_R_al)) std([FI_R_on FI_R_off])/sqrt(length([FI_R_on FI_R_off])) std(FI_R_int)/sqrt(length(FI_R_int))];
Stdvali=[std(FI_al) std(FI_on) std(FI_off) std(FI_R_al) std(FI_R_on) std(FI_R_off)];

figure;bar(meanvali);
ax = gca;
ax.XTickLabel = {'all chirps FR','++/-- chirps FR','+- chirps FR','all chirps COR', '++/-- chirps COR','+- chirps COR'};
ax.XTickLabelRotation = 45;
hold on;
errorbar(meanvali,SEvali,'k.')
box off
title('invariance score single units');ylabel('Invariance');

% ANOVA with Bonferroni PostHoc
gr1=ones(1,length(FI_al));gr2=1+ones(1,length([FI_on FI_off]));gr3=2+ones(1,length(FI_int));
gr4=3+ones(1,length(FI_R_al));gr5=4+ones(1,length([FI_R_on FI_R_off]));gr6=5+ones(1,length(FI_R_int));
groups=[gr1 gr2 gr3 gr4 gr5 gr6];
FIS=[FI_al [FI_on FI_off] FI_int FI_R_al [FI_R_on FI_R_off] FI_R_int];

[p,table,stats]=anova1(FIS,groups,'off');
if stats.df==0
else
    if table{2,6}<0.05
        figure;[c,m,h] = multcompare(stats,'ctype','bonferroni');
    else
        display('NO significant differences between groups')
    end
end
clear p table stats c m h
%----------------------
%% reponse tuning
phases=(pi/4:pi/4:(8*pi/4));

% single neurons
loggFR=real(log(valFR));
loggFR(isinf(loggFR))=NaN;
meanvallogFR=nanmean(loggFR,1);
SEMvalFR=nanstd(loggFR,1)./sqrt(size(loggFR,1));
figure;errorbar(phases,meanvallogFR([7 6 5 4 3 2 1 8]),SEMvalFR([7 6 5 4 3 2 1 8]));
ylim([-(min(SEMvalFR)-min(meanvallogFR)+0.1) (max(SEMvalFR)+max(meanvallogFR)+0.05)])
ylabel('Invariance Score');xlabel('Phase (rad)')
box off
figure;plot(phases,meanvallogFR([7 6 5 4 3 2 1 8])./max(abs(meanvallogFR)))
title('Response Tuning Single Unit');xlabel('Phase (rad)')
ylabel('Normalized Invariance Score')
ylim([-1 1])
box off

% correlations
loggRR=real(log(valRR));
loggRR(isinf(loggRR))=NaN;
meanvallogRR=nanmean(loggRR,1);
SEMvalRR=nanstd(loggRR,1)./sqrt(size(loggRR,1));
figure;errorbar(phases,meanvallogRR([7 6 5 4 3 2 1 8]),SEMvalRR([7 6 5 4 3 2 1 8]));
ylim([-(min(SEMvalRR)+min(meanvallogRR)) (max(SEMvalRR)+max(meanvallogRR))])
ylabel('Invariance Score');xlabel('Phase (rad)')
box off

figure;plot(phases,meanvallogRR([7 6 5 4 3 2 1 8])./max(abs(meanvallogRR)))
ylabel('Normalized Invariance Score');xlabel('Phase (rad)')
title('Response Tuning Correlated Activity')
ylim([-1 1])
box off
