%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Metzen et al. Neural correlations enable invariant coding and perception
% of natural stimuli
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% similarity measure between signals
function [sm,sm2]=simmeas(y,yhat)

% normalize 
if sum(y)~=0
    ytemp=((y - min(y)) / ( max(y) - min(y) ));
else
    ytemp=y;
end

if sum(yhat)~=0
    yhattemp=((yhat - min(yhat)) / ( max(yhat) - min(yhat) ));
else
    yhattemp=yhat;
end
% unnormalized
% % ytemp=y;
% % yhattemp=yhat;

if length(ytemp)>length(yhattemp)
    ytemp=ytemp(1:length(yhattemp));
end

if length(yhattemp)>length(ytemp)
    yhattemp=yhattemp(1:length(ytemp));
end

% figure;plot(ytemp);hold on;plot(yhattemp,'r')

RMSE = sqrt(mean((ytemp-yhattemp).^2)); 
% RMSE = sqrt(mean(((ytemp - mean(ytemp))-(yhattemp + mean(yhattemp))).^2));  % Root Mean Squared Error
errmax = max((max(ytemp)/sqrt(2)-min(ytemp)/sqrt(2)),(max(yhattemp)/sqrt(2)-min(yhattemp)/sqrt(2)));

if sum(errmax)~=0
    sm = 1 - RMSE/errmax;
    sm2 = RMSE/errmax;
else
    sm=1-RMSE;
    sm2=RMSE;
end
end
%  [sm]=simmeas(((chirp2(1:end-1) - min(chirp2(1:end-1))) / ( max(chirp2(1:end-1)) - min(chirp2(1:end-1)) )),((psth1 - min(psth1)) / ( max(psth1) - min(psth1) )))
