%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Metzen et al. Neural correlations enable invariant coding and perception
% of natural stimuli
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% tuning curve midbrain neurons chirps
% code to analyze neuronal data of midbrain TS
% 1st update Jan 2016
% 2nd update Feb 2016 removed PEAK RESPONSE ALIGNMENT for all measures

clc
clear
close all
beat=4;
% select folder containing midbrain TS data
% cd('J:\eLife_resub1\data_midbrain')
warning off
FileList=dir('*.mat');
nn=size(FileList,1);
%--update Jan 2016-----
baselines=[];
%----------------------
for rot=1:nn
    load(FileList(rot).name);
    %--update Jan 2016-----
    baselines=[baselines baseline];
    %----------------------
    for gelb=1:8
        chirptimes=ctimes(gelb).chirptime;
        bin=binary(gelb).binA;
        stimulus=stim(gelb).stim;
        [B,A]=butter(1,0.05);
        dif_stim=abs(diff(filtfilt(B,A,stimulus)))'; % get chirp onsets
        allbinchirps=[0;diff(dif_stim>0.065)==1];
        chirptimestemp=find((allbinchirps==1));
        time=1:1:length(stimulus);
        chirptimestemp=chirptimestemp(diff(chirptimestemp)>(0.03*2000)); %(0.06*2000)
        for blau=1:length(chirptimestemp)
            chirptimes(blau)=time(dif_stim==max(dif_stim (time>chirptimestemp(blau)-(0.5*2000) & time<=chirptimestemp(blau)+(0.5*2000))));
        end
        spiketimes1=(find(bin==1))/10000;
        spiketimes1=spiketimes1;
        %--update Jan 2016-----
        spiketimes2=spiketimes1+0.006; % account for synaptic delay
        %----------------------
        newdt=1/10000;
        cycl=4*(1/beat)*10000; % we want 4 cycles
        dur=cycl/10/2;% half psth duration
        timewindow=0.03; % in s
        chirp_indices=(chirptimes);
        psth=zeros(round(dur*2/newdt/1000),1);
        %--update Jan 2016-----
        psthT=zeros(round(dur*2/newdt/1000),1);
        %----------------------
        %         figure;                              % Create a new figure
        %         subplot(3,1,1);
        stimulusnew=stimulus(chirp_indices(10)-round(dur/newdt/1000):chirp_indices(10)+round(dur/newdt/1000));
        %         plot(-round(dur/newdt/1000)*newdt:newdt:round(dur/newdt/1000)*newdt,stimulus(chirp_indices(1)-round(dur/newdt/1000):chirp_indices(1)+round(dur/newdt/1000)));
        %         axis([-newdt/2*length(psth) newdt/2*length(psth) 1.1*min(stimulus) 1.1*max(stimulus)]);hold on;plot([0 0],[-1 1],'r','LineWidth',1.5);hold on;plot([timewindow timewindow],[-1 1],'r','LineWidth',1.5)
        %         subplot(3,1,2);hold on;
        for I=1:length(chirp_indices);
            spiketimes=spiketimes1(find(spiketimes1>newdt*(round(chirp_indices(I))-round(dur/newdt/1000)) & spiketimes1<=newdt*(round(chirp_indices(I))+round(dur/newdt/1000))));
            %--update Jan 2016-----
            spiketimesB=spiketimes2(find(spiketimes2>newdt*(round(chirp_indices(I))-round(dur/newdt/1000)) & spiketimes2<=newdt*(round(chirp_indices(I))+round(dur/newdt/1000))));
            %----------------------
            %             plot(spiketimes-newdt*(round(chirp_indices(I))),ones(length(spiketimes),1)*I,'k.');
            if length(spiketimes)>0
                spiketimes=spiketimes-newdt*(round(chirp_indices(I))-round(dur/newdt/1000));
                if spiketimes(1)<0.0001
                    spiketimes(1)=[];
                end
                binaryT=zeros(length(psth),1);
                binaryT(round(spiketimes/newdt))=1;
                psth=psth+binaryT;
            end
            
            %--update Jan 2016-----
            if length(spiketimesB)>0
                spiketimesB=spiketimesB-newdt*(round(chirp_indices(I))-round(dur/newdt/1000));
                if spiketimesB(1)<0.0001
                    spiketimesB(1)=[];
                end
                binaryTT=zeros(length(psthT),1);
                if spiketimesB(1)<0.0001
                    spiketimesB(1)=[];
                end
                binaryTT(round(spiketimesB./newdt))=1;
                psthT=psthT+binaryTT;
                
            end
            %----------------------
            clear spiketimes spiketimesB binaryT binaryTT
        end
        %         hold off;
        psth=psth/length(chirp_indices)/newdt;
        %--update Jan 2016-----
        psthT=psthT/length(chirp_indices)/newdt;
        %----------------------
        A=ones(1,60);
        A=A/length(A);
        psth=conv(A,psth);
        psth=psth(1:end-length(A)+1);
        %--update Jan 2016-----
        psthT=conv(A,psthT);
        psthT=psthT(1:end-length(A)+1);
        psthT_mat(:,gelb)=psthT./2;
        %----------------------
        psth_mat(:,gelb)=psth./2;
        stim_new(:,gelb)=stimulusnew;
        %--update Jan 2016-----
        timeindex=round(timewindow/newdt);
        % beat response
        mean_beat=mean(psth([1:round(length(psth)/2-(timeindex))]));% round(length(psth)/2+(timeindex)+500):end]));
        FRbeattemp(:,gelb)=mean_beat;
        %----------------------
        %         axis([-newdt/2*length(psth) newdt/2*length(psth) 0 length(chirp_indices)])
        %         subplot(3,1,3);
        %         plot(newdt*(1:1:length(psth))-newdt/2*length(psth),psth);
        %         if max(psth)>0
        %             axis([-newdt/2*length(psth) newdt/2*length(psth) 0 200])
        %         else
        %             axis([-newdt/2*length(psth) newdt/2*length(psth) 0 200])
        %         end
        clear A bin chirp_indices chirptimes cycl dur newdt psth spiketimes1 stimulus stimulusnew timetempnew mean_beat psthT
        close all
    end
    %%
    for gold=1:8
        eval(['psthSC' num2str(gold) '(:,rot)=psth_mat(:,gold);']);
        eval(['stimSC' num2str(gold) '(:,rot)=stim_new(:,gold);']);
        %--update Jan 2016-----
        eval(['psthTSC' num2str(gold) '(:,rot)=psthT_mat(:,gold);']);
        eval(['FRbeat' num2str(gold) '(:,rot)=FRbeattemp(:,gold);']);
        %----------------------
    end
    clear gelb psth_mat datamat filename timetempnew FRbeattemp psthT_mat
end
keep nn FRbeat1 FRbeat2 FRbeat3 FRbeat4 FRbeat5 FRbeat6 FRbeat7 FRbeat8 baselines psthSC1 psthSC2 psthSC3 psthSC4 psthSC5 psthSC6 psthSC7 psthSC8 timewindow stimSC1 stimSC2 stimSC3 stimSC4 stimSC5 stimSC6 stimSC7 stimSC8 psthTSC1 psthTSC2 psthTSC3 psthTSC4 psthTSC5 psthTSC6 psthTSC7 psthTSC8

%% take only chirpwindow
close all
clear onPSTHS MeanOn StdOn SemOn filtMeanOn filtSemOn stim
newdt=1/10000;
timewin=timewindow/newdt;
timezero=round(length(psthSC1)*0.5);
onPSTHS{1}=psthSC1(timezero:timezero+timewin,:);
onPSTHS{2}=psthSC2(timezero:timezero+timewin,:);
onPSTHS{3}=psthSC3(timezero:timezero+timewin,:);
onPSTHS{4}=psthSC4(timezero:timezero+timewin,:);
onPSTHS{5}=psthSC5(timezero:timezero+timewin,:);
onPSTHS{6}=psthSC6(timezero:timezero+timewin,:);
onPSTHS{7}=psthSC7(timezero:timezero+timewin,:);
onPSTHS{8}=psthSC8(timezero:timezero+timewin,:);

%--update Jan 2016-----
onPSTHST{1}=psthTSC1(timezero:timezero+timewin,:);
onPSTHST{2}=psthTSC2(timezero:timezero+timewin,:);
onPSTHST{3}=psthTSC3(timezero:timezero+timewin,:);
onPSTHST{4}=psthTSC4(timezero:timezero+timewin,:);
onPSTHST{5}=psthTSC5(timezero:timezero+timewin,:);
onPSTHST{6}=psthTSC6(timezero:timezero+timewin,:);
onPSTHST{7}=psthTSC7(timezero:timezero+timewin,:);
onPSTHST{8}=psthTSC8(timezero:timezero+timewin,:);
%----------------------

stim{1}=stimSC1(timezero:timezero+timewin,:);
stim{2}=stimSC2(timezero:timezero+timewin,:);
stim{3}=stimSC3(timezero:timezero+timewin,:);
stim{4}=stimSC4(timezero:timezero+timewin,:);
stim{5}=stimSC5(timezero:timezero+timewin,:);
stim{6}=stimSC6(timezero:timezero+timewin,:);
stim{7}=stimSC7(timezero:timezero+timewin,:);
stim{8}=stimSC8(timezero:timezero+timewin,:);

%--update Jan 2016-----
FRbeat{1}=FRbeat1;
FRbeat{2}=FRbeat2;
FRbeat{3}=FRbeat3;
FRbeat{4}=FRbeat4;
FRbeat{5}=FRbeat5;
FRbeat{6}=FRbeat6;
FRbeat{7}=FRbeat7;
FRbeat{8}=FRbeat8;
%----------------------

tchirpPSTHs=(0:newdt:timewin*newdt);

for lila=1:size(onPSTHS,2)
    MeanOn(1:timewin+1,lila) = mean(onPSTHS{lila},2);
    maxmean(lila)=max(mean(onPSTHS{lila},2));
    %--update Jan 2016-----
    MeanOnT(1:timewin+1,lila) = mean(onPSTHST{lila},2);
    maxmeanT(lila)=max(mean(onPSTHST{lila},2));
    %----------------------
    MeanStim(1:timewin+1,lila) = mean(stim{lila},2);
    StdOn(1:timewin+1,lila) = std(onPSTHS{lila},0,2);
    SemOn(1:timewin+1,lila) = (StdOn(:,lila)./sqrt(size(onPSTHS{lila},2)));
end

[B,A] = butter(1,0.1);
for grau = 1:size(MeanOn,2)
    filtMeanOn(1:size(MeanOn,1),grau) = filtfilt(B,A,MeanOn(:,grau));
    filtMeanOnT(1:size(MeanOnT,1),grau) = filtfilt(B,A,MeanOnT(:,grau));
    filtSemOn(1:size(MeanOn,1),grau) = filtfilt(B,A,SemOn(:,grau));
end

figure;
for orange=[7 6 5 4]
    hold on
    plot(tchirpPSTHs,filtMeanOnT(:,orange),'k');
end
for orange=[3 2 1 8]
    hold on
    plot(tchirpPSTHs,filtMeanOnT(:,orange),'r');
end
xlabel('Time (s)');ylabel('Firing Rate (Hz)');
t=text([0.0025 0.0025],[85 78],{'+ Chirps';'- Chirps'});
t(1).FontSize = 14;
t(2).FontSize = 14;
t(2).Color = 'red';
hold off;
clear MeanOnT maxmeanT filtMeanOnT onPSTHST psthTSC1 psthTSC2 psthTSC3 psthTSC4 psthTSC5 psthTSC6 psthTSC7 psthTSC8
%%
%--update Jan 2016-----
% do computation for each cell individually
[B,A] = butter(1,0.07);
for lola=1:nn
    qq=(lola);
    % align peak responses
    for lila=1:size(onPSTHS,2)
        temp=(filtfilt(B,A,(onPSTHS{1, lila}(:,lola))));
        neuron(:,lila)=temp;
        denumm(lila,:)=FRbeat{1, lila}(:,lola);
        clear temp lagA lagB
    end
    newfrm=neuron;
    %% invariance measure
    % all chirps
    num_stim=size(neuron,2);
    pairs=nchoosek(1:1:num_stim,2);
    FRM=neuron;
    FRM(:,[])=[];
    SCMT=MeanStim;
    SCMT(:,[])=[];
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_FR(I)]=simmeas(FRM(:,take(1)),FRM(:,take(2)));
        [~,sim_SC(I)]=simmeas(SCMT(:,take(1)),SCMT(:,take(2)));
    end
    sim_SC3=sim_SC;
    ind3=find(~isnan(sim_FR));

    ratio=(sim_FR(ind3)./sim_SC(ind3));
    ratio(ratio>1)=1;
    %--update Feb 2016-----
    simiFR{lola}.sim=sim_FR;
    simiSC{lola}.sim=sim_SC;
    %----------------------
    if (1-((sum(ratio))/(length(ratio))))<= 0 
        FI_norm(lola)=NaN;
    else
        FI_norm(lola)=1-((sum(ratio))/(length(ratio)));
    end
    clear pairs ratio
    %% only minus chirps
    FRMoff=neuron;
    FRMoff(:,[4 5 6 7])=[];
    SCMToff=MeanStim;
    SCMToff(:,[4 5 6 7])=[];
    num_stim=size(FRMoff,2);
    pairs=nchoosek(1:1:num_stim,2);
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_FR_OFF(I)]=simmeas(FRMoff(:,take(1)),FRMoff(:,take(2)));
        [~,sim_SC_OFF(I)]=simmeas(SCMToff(:,take(1)),SCMToff(:,take(2)));
    end
    sim_SC2=sim_SC_OFF;
    ind2=find(~isnan(sim_FR_OFF));
    ratio=(sim_FR_OFF(ind2)./sim_SC_OFF(ind2));
    ratio(ratio>1)=1;
    if (1-((sum(ratio))/(length(ratio))))<=  0 
        FI_OFF(qq)=NaN;
    else
        FI_OFF(qq)=1-((sum(ratio))/(length(ratio)));
    end
    clear pairs ratio
    %% only plus chirps
    FRMon=neuron;
    FRMon(:,[3 2 1 8])=[];
    SCMTon=MeanStim;
    SCMTon(:,[3 2 1 8])=[];
    num_stim=size(FRMon,2);
    pairs=nchoosek(1:1:num_stim,2);
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_FR_ON(I)]=simmeas(FRMon(:,take(1)),FRMon(:,take(2)));
        [~,sim_SC_ON(I)]=simmeas(SCMTon(:,take(1)),SCMTon(:,take(2)));
    end
    sim_SC1=sim_SC_ON;
    ind1=find(~isnan(sim_FR_ON));
    ratio=(sim_FR_ON(ind1)./sim_SC_ON(ind1));
    ratio(ratio>1)=1;
    if (1-((sum(ratio))/(length(ratio))))<= 0
        FI_ON(qq)=NaN;
    else
        FI_ON(qq)=1-((sum(ratio))/(length(ratio)));
    end
    clear pairs ratio
    %% inter chirps (plus/minus)
    FRMinter=neuron;
    SCMTinter=MeanStim;
    takeon=[4 5 6 7];
    takeoff=[1 2 3 8];
    
    pairs=combvec(takeon,takeoff)';
    for I=1:size(pairs,1)
        take=pairs(I,:);
        [~,sim_FR_int(I)]=simmeas(FRMinter(:,take(1)),FRMinter(:,take(2)));
        [~,sim_SC_int(I)]=simmeas(SCMTinter(:,take(1)),SCMTinter(:,take(2)));
    end
    sim_SC4=sim_SC_int;
    ind4=find(~isnan(sim_FR_int));
    ratio=(sim_FR_int(ind4)./sim_SC_int(ind4));
    ratio(ratio>1)=1;
    if (1-((sum(ratio))/(length(ratio))))<= 0
        FI_int(qq)=NaN;
    else
        FI_int(qq)=1-((sum(ratio))/(length(ratio)));
    end
    clear neuron newfrm sim_FR sim_SC FRMon FRMoff FRM SCMTon SCMToff SCMT pairs ratio
end
%%
figure; % scatter plot sim stim vs sim resp for each neuron
for MG=1:size(simiSC,2)
    hold on;plot(simiSC{1,MG}.sim,simiFR{1,MG}.sim,'.','markersize',10)
end
xlim([0.1 1.25]);ylim([0.1 1.25])
hold on;refline(1,0)
title('single cells');xlabel('Distance Stimulus');ylabel('Distance Response');logx;logy

thresh=0; %
FIall=nanmean(FI_norm(FI_norm>thresh))
ind_invar=find(FI_norm>thresh);
SEMFIall=nanstd(FI_norm(FI_norm>thresh))/sqrt(sum((FI_norm(FI_norm>thresh))>-1000));

FIintra=nanmean([FI_ON(ind_invar) FI_OFF(ind_invar)])
SEMFIintra=nanstd([FI_ON(ind_invar) FI_OFF(ind_invar)])/sqrt(sum(~isnan([FI_ON(ind_invar) FI_OFF(ind_invar)])));

FIinter=nanmean(FI_int(ind_invar))
SEMFIint=nanstd(FI_int(ind_invar))/sqrt(sum(~isnan(FI_int)));

figure;bar([1 2 3],[FIall FIintra FIinter]);
ax = gca;
ax.XTickLabel = {'all chirps','intra chirps', 'inter chirps'};
ax.XTickLabelRotation = 45;
hold on;errorbar([1 2 3],[FIall FIintra FIinter],[SEMFIall SEMFIintra SEMFIint],'.');
box off
ylim([0 .5])
title('FI scores based on single cells')

% ANOVA with Bonferroni PostHoc
gr1=ones(1,length(FI_norm(ind_invar)));gr2=1+ones(1,length([FI_ON(ind_invar) FI_OFF(ind_invar)]));gr3=2+ones(1,length(FI_int(ind_invar)));
groups=[gr1 gr2 gr3];
FIS=[FI_norm(ind_invar) [FI_ON(ind_invar) FI_OFF(ind_invar)] FI_int(ind_invar)];

[p,table,stats]=anova1(FIS,groups,'off');
if stats.df==0
else
    if table{2,6}<0.05
        figure;[c,m,h] = multcompare(stats,'ctype','bonferroni');
    else
        display('NO significant differences between groups')
    end
end
clear p table stats c m h

%% response tuning single units
clear val valA valB loggy
thresh=0.25; % treshold based on MEAN ELL pyramidal values + 1*STD
ind_invar=find(FI_norm>thresh);
length(ind_invar)
ONindi=find((~isnan(FI_ON)));
OFFindi=find((~isnan(FI_OFF)));
q=1;
qq=1;
for lola=1:nn
        for lila=1:size(onPSTHS,2)
            temp=(filtfilt(B,A,(onPSTHS{1, lila}(:,lola))));
            neuronA(:,lila)=temp;
            denummA(lila,:)=FRbeat{1, lila}(:,lola);
            clear temp lagA lagB
        end
        newfrmA=neuronA;
        for I=1:8
            ind=(find(tchirpPSTHs>=(0.015-0.01) & tchirpPSTHs<=(0.015+0.01)));
            valA(q,I)=(mean(newfrmA(ind,I))/mean(denummA));
            if baselines(q)==0
                nennerA=0.001;
            else
                nennerA=baselines(q);
            end
            %         valA(q,I)=(mean(newfrm(ind,I))/nennerA);
        end
        clear denummA
        q=q+1;
end
val=valA(ind_invar,:);
phases=(pi/4:pi/4:(8*pi/4));
loggy=log(val);
loggy(isinf(loggy))=NaN;
meanvalloggy=nanmean(loggy,1);
SEMval=nanstd(loggy,1)./sqrt(sum(~isnan(loggy)));
figure;errorbar(phases,meanvalloggy([7 6 5 4 3 2 1 8]),SEMval([7 6 5 4 3 2 1 8]));
ylim([-max(meanvalloggy)-max(SEMval) max(meanvalloggy)+max(SEMval)])
title('Response Tuning - single cells');xlabel('Phase (rad)')
ylabel('Invariance Score')
box off

figure;plot(phases,meanvalloggy([7 6 5 4 3 2 1 8])./max(abs(meanvalloggy)))
title('Response Tuning - single cells');xlabel('Phase (rad)')
ylabel('Normalized Invariance Score')
ylim([-1 1])
box off

%% FI measure and tuning on TS population
%----update Feb 2016-----
onPSTHSnew=onPSTHS;
close all
for cyan=1:size(onPSTHSnew,2)
    MeanOn(1:timewin+1,cyan) = mean(onPSTHSnew{cyan},2);
end

[B,A] = butter(1,0.1);
for grau = 1:size(MeanOn,2)
    filtMeanOnnew(1:size(MeanOn,1),grau) = filtfilt(B,A,MeanOn(:,grau));
end

newfrm=filtMeanOnnew;
% % invariance measure
num_stim=size(newfrm,2);
pairs=nchoosek(1:1:num_stim,2);

for I=1:size(pairs,1)
    take=pairs(I,:);
    [~,sim_FR2(I)]=simmeas(newfrm(:,take(1)),newfrm(:,take(2)));
    [~,sim_SC(I)]=simmeas(MeanStim(:,take(1)),MeanStim(:,take(2)));
end

sim_SC22=sim_SC;
ind22=find(isnan(sim_FR2));
sim_FR2(ind22)=[];
sim_SC22(ind22)=[];

ratio=sim_FR2./sim_SC22;
ratio(ratio>1)=1;
FI_pop_all=1-((sum(ratio))/(length(ratio)));
clear ratio
%----------------------
